import com.urbancode.anthill3.AHPTool
import com.urbancode.anthill3.CommandHelper

def ahpTool = new AHPTool()
def props = ahpTool.getStepProperties()

def viewPath = props['source/storageDir']
def commandPath = props['source/repo/commandPath']
def lockObjs = props['source/lockObjs']

if (lockObjs == null || lockObjs.trim().length() == 0) {
    println "No lockable objects configured on the source config!"
    System.exit(1)
}
def lockObjArray = lockObjs.split('\n')

File workDirFile = new File(viewPath)

if(!workDirFile.exists()) {
    throw new IllegalStateException("The view path does not exist: " + viewPath)
}

def ch = new CommandHelper(workDirFile)

if (commandPath == null || commandPath.trim().length() == 0) {
    commandPath = "cleartool"
}

final def unlock = {
    def tempArgs = [commandPath, 'unlock', '-nc']
    lockObjArray.each { lockObj ->
        tempArgs << lockObj
    }

    ch.runCommand("Unlocking objects", tempArgs)
}

if (lockObjArray != null && lockObjArray.length >0) {
    //we need to try to unlock first
    unlock()
}
else {
    println "Failed to unlock object(s)"
}